{System/conversion/conversion_progress.i}

DEF VAR cProgram                      AS CHARACTER NO-UNDO.
DEF VAR cAction                       AS CHARACTER NO-UNDO.
DEF VAR cTable                        AS CHARACTER NO-UNDO.
DEF VAR iTotal                        AS INTEGER   NO-UNDO.
DEF VAR iDone                         AS INTEGER   NO-UNDO.
DEF VAR iLoop                         AS INTEGER   NO-UNDO.
DEF VAR iModulo                       AS INTEGER   NO-UNDO.

DEF VAR cEdiSender                    AS CHARACTER NO-UNDO.

DISABLE TRIGGERS FOR LOAD OF dp-mapper.

DEFINE BUFFER b-dp-mapper FOR dp-mapper.

ASSIGN
  cProgram = THIS-PROCEDURE:FILE-NAME
  cAction  = "convert subcustomer mappings"
  cTable   = "dp-mapper"
  iTotal   = 0
  iDone    = 0
  iModulo  = 10
  .

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).


/* Tellen */
FOR EACH dp-mapper WHERE
         dp-mapper.maptype  = "COPARN-EXTRA"
     AND dp-mapper.mapfield = "SUBCUSTOMER"
  NO-LOCK:
  iTotal = iTotal + 1.
END.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).


/* uitvoeren */
FOR EACH dp-mapper WHERE
         dp-mapper.maptype  = "COPARN-EXTRA"
     AND dp-mapper.mapfield = "SUBCUSTOMER"
  EXCLUSIVE-LOCK:

  cEdiSender = "".

  FIND FIRST dp-customer WHERE
             dp-customer.shortname = dp-mapper.mapcust
    NO-LOCK NO-ERROR.

  IF AVAILABLE dp-customer
  THEN DO:


    IF dp-customer.edi-unb-receiver <> ""
    THEN cEdiSender = dp-customer.edi-unb-receiver.

    FOR EACH dp-customer-edi WHERE
             dp-customer-edi.companycode          = dp-customer.companycode
         AND dp-customer-edi.cust_addressnr       = dp-customer.cust_addressnr
         AND dp-customer-edi.group_code           = "COPRAR"
         AND dp-customer-edi.ediparameter         = "UNBRECEIVER"
              /* Alleen algemene instellingen overnemen en niet hele specifieke */
         AND dp-customer-edi.depotcode            = ""
         AND dp-customer-edi.subcust_addressnr    = 0
         AND dp-customer-edi.lesseenr             = 0
      NO-LOCK:
      IF dp-customer-edi.edivalue <> ""
      THEN cEdiSender = dp-customer-edi.edivalue.
    END.

    FIND b-dp-mapper WHERE
         b-dp-mapper.maptype        = "COPRAR"
     AND b-dp-mapper.mapcust        = cEdiSender
     AND b-dp-mapper.mapfield       = "SUBCUSTOMER"
     AND b-dp-mapper.external_value = dp-mapper.external_value
      NO-LOCK NO-ERROR.

    IF NOT AVAILABLE b-dp-mapper
    THEN DO:
      CREATE b-dp-mapper.
      ASSIGN
        b-dp-mapper.maptype        = "COPRAR"
        b-dp-mapper.mapcust        = cEdiSender
        b-dp-mapper.mapfield       = "SUBCUSTOMER"
        b-dp-mapper.external_value = dp-mapper.external_value
        b-dp-mapper.internal_value = dp-mapper.internal_value
        .
    END. /* IF NOT AVAILABLE b-dp-mapper */

  END. /* IF AVILABLE dp-customer */


  DELETE dp-mapper.

  iDone = iDone + 1.

  IF iDone MOD iModulo = 0
  THEN RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

END.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).


